\\ ---------- Methods for the computation of period polynomials ----------

PP_Integrals(f,k)={
		     local(fint=vector(k));
		     fint[1]=truncate(intformal(f/x));
		     for(i=2,k,fint[i]=intformal(fint[i-1]/x));
		     vector(k,X,fint[X]/(2*Pi*I)^X)~
		  };

PP_SL2(g,tau)=(g[1,1]*tau+g[1,2])/(g[2,1]*tau+g[2,2]);

PP_Boundary(P,g,n)=(g[2,1]*tau+g[2,2])^(-n)*subst(P,tau,PP_SL2(g,tau))-P;

PP_PerPol(fi,g)={
		   local(k=#fi,p1,p2,tmp1,tmp2,tau0=(I+g[1,1]*sign(g[2,1]))/max(1,abs(g[2,1])),tau1=PP_SL2(matsolve(g,matid(2)),tau0));
		   
		   p1=(tau-z)^(k-2);
		   p2=subst(bernpol(k-1,tau),tau,tau-z);
                   p2=p2-subst(p2,z,0);
		   p2=PP_Boundary(p2,g,2-k)/(k-1);
		   tmp1=sum(i=0,k-2,polcoef(p1,i,z)*sum(j=0,i,(-1)^j*i!/(i-j)!*tau0^(i-j)*subst(fi[j+1],x,exp(2*Pi*I*tau0))))-sum(i=0,k-2,polcoef(p1,i,z)*sum(j=0,i,(-1)^j*i!/(i-j)!*tau1^(i-j)*subst(fi[j+1],x,exp(2*Pi*I*tau1))));
		   tmp2=sum(i=0,k-1,polcoef(p2,i,z)*sum(j=0,i,(-1)^j*i!/(i-j)!*(tau0-1)^(i-j)*subst(fi[j+1],x,exp(2*Pi*I*tau0))))-sum(i=0,k-1,polcoef(p2,i,z)*sum(j=0,i,(-1)^j*i!/(i-j)!*tau0^(i-j)*subst(fi[j+1],x,exp(2*Pi*I*tau0))));
		   
		   (2*Pi*I)^(k-1)/(k-2)!*(tmp1+tmp2)
		};



\\ ---------- Computations ----------

default(parisize,"1G")
default(realprecision,"1000")
default(format,"g.15")

ord = 3000;

[f] = mfeigensearch([72,4],[[5,-14]]);
f = Ser(mfcoefs(f,ord));
fi = PP_Integrals(f,4);
fPol = PP_PerPol(fi,[41,-4;72,-7]);
wfp = real(subst(fPol,tau,0))/(-61);
wfm = I*imag(subst(fPol,tau,0))/(-9);
print("Periods of f: ",[wfp,wfm]);
print("Checking period polynomial of f: ",fPol-(wfp*(-61+1224*tau-6264*tau^2)+wfm*(-9+180*tau-936*tau^2)),"\n");

eps = 1/10^2;

E4 = mfEk(4);
mf = mfinit(E4);
print("Checking period identity for E4/sqrt(-j/1728): ",(2*Pi*I)^3/2*I*intnum(x=eps,1/eps,(tau-I*x)^2*mfeval(mf,E4,I*x)/sqrt(-ellj(I*x)/1728))-(-432*wfp*tau+108*wfm*(1-tau^2)));
